library(dplyr)
library(tidyverse)

#Used for getting arguments from user 
args = commandArgs(trailingOnly=TRUE)
colIndex <- 2
MatchedList <- as.array(as.numeric(strsplit(args[2], ',')[[1]]))
colIndex <- c(colIndex , MatchedList)
ColHeaders <- NULL
AllSubReportContent <- NULL
ReportContent <- NULL
i <- FALSE
for (subdir in list.dirs(args[1], full.names = TRUE,recursive=FALSE)){
  #ReportContent <- NULL 
  for(file in list.files(subdir)){
    ReportsPath <<- paste0(subdir , '\\' , file)
    ColHeaders <<- c(ColHeaders , file)
    if (as.numeric(args[3]) == 0)
      ReportContent <<- read.csv(ReportsPath , sep = "\t")
    else
      ReportContent <<- read.csv(ReportsPath)
    
    SelectedIndecies <<- ReportContent[,colIndex]
    UniqueColname <<- colnames(SelectedIndecies)[1]
    if (!i)
      AllSubReportContent <<- SelectedIndecies
    else
      AllSubReportContent <<- full_join(AllSubReportContent, SelectedIndecies, by=UniqueColname)
    i <<- TRUE
  }
  "Apply processing on OutputData"
  AllSubReportContent <- AllSubReportContent[,order(names(AllSubReportContent))]
  Names <- rep(ColHeaders , length(MatchedList))
  NamesList <- c(colnames(AllSubReportContent)[1] , Names)
  colnames(AllSubReportContent) <- NamesList
  OutputPath <- paste0(subdir , '\\' , 'OutputData.csv')
  write.csv(AllSubReportContent, OutputPath)
  ReportContent <<- NULL
  AllSubReportContent <<- NULL
  ColHeaders <<- NULL
  i <<- FALSE
}
